using System;
using System.Collections;
using System.Text;
using MySql.Data.MySqlClient;

namespace MySQLBug29877
{
	class Program
	{
		static private MySql.Data.MySqlClient.MySqlConnection
			conn = null;
		static private MySql.Data.MySqlClient.MySqlCommand
			cmd = null;
		static private MySql.Data.MySqlClient.MySqlDataAdapter
			da = null;
		static private MySql.Data.MySqlClient.MySqlCommandBuilder
			cmdBuilder = null;

		static private System.Data.DataSet SystemDataDataSet = null;
		static private System.Data.DataView SystemDataDataView = null;
		static private System.Data.DataRow SystemDataDataRow = null;

		static private System.Byte[] SystemBytes = new System.Byte[] { (byte)'a',(byte)'b', (byte)'c'};

		static void Main(string[] args)
		{
			try
			{
				conn = new MySql.Data.MySqlClient.MySqlConnection();
				cmd = new MySql.Data.MySqlClient.MySqlCommand();
				da = new MySql.Data.MySqlClient.MySqlDataAdapter();
				cmdBuilder = new MySql.Data.MySqlClient.MySqlCommandBuilder();

				SystemDataDataSet = new System.Data.DataSet();
				SystemDataDataView = new System.Data.DataView();

				conn.ConnectionString = "Data Source=localhost;Port=3306;Database=mysql_bug_29877;User Id=root;Password=";
				conn.Open();

                MySqlCommand cmdCreateTable = new MySqlCommand("DROP TABLE IF EXISTS Bug29877", conn);
                cmdCreateTable.CommandTimeout = 0;
                cmdCreateTable.ExecuteNonQuery();
                cmdCreateTable.CommandText = "CREATE TABLE Bug29877 (" +
                    "id INTEGER UNSIGNED NOT NULL auto_increment," +
                    "tinyint_value TINYINT UNSIGNED," +
                    "PRIMARY KEY  (id)" +
                ") ENGINE=InnoDB DEFAULT CHARSET=utf8";
                cmdCreateTable.ExecuteNonQuery();

                cmd.CommandType=System.Data.CommandType.Text;
				cmd.Connection= conn;
                cmd.CommandText = "SELECT * FROM Bug29877";
			    da.SelectCommand =cmd;
                da.Fill(SystemDataDataSet, "Bug29877");
				cmdBuilder.DataAdapter = da;
                cmdBuilder.DataAdapter.SelectCommand.CommandText = "SELECT * FROM Bug29877";
				cmdBuilder.RefreshSchema();

                SystemDataDataView = SystemDataDataSet.Tables["Bug29877"].DefaultView;

				SystemDataDataRow = SystemDataDataView.Table.NewRow();
				SystemDataDataRow["tinyint_value"] = 1;

                SystemDataDataView.Table.Rows.Add(SystemDataDataRow);

               
				System.Console.WriteLine("ID before update: " + SystemDataDataRow["id"]);
                da.Update(SystemDataDataSet, "Bug29877");
				System.Console.WriteLine("ID after update: "  + SystemDataDataRow["id"]);
			}

			catch (System.Exception SystemException)
			{
				System.Console.WriteLine(SystemException.Message);
			}
		}
	}
}